      SUBROUTINE AFB2D(A,MA,N,ML,MU,NLEAD,RCOND,Z,IERR)
         INTEGER IERR,MA,ML,MU,N,NLEAD
         DOUBLE PRECISION A,RCOND,Z
         DIMENSION A(MA,1),NLEAD(1),Z(1)
         EXTERNAL UTAFSI
         INTEGER        I,I0,I1,J,J0,J1,JJ,JU,JZ,K,KB,KP1,L,LL,LM,M,
     1           MM,NM1
         DOUBLE PRECISION ANORM,EK,S,SM,T,WK,WKM,X,YNORM
       RCOND = 0.0D0
       X = 0.0D0
   10  CONTINUE
       IF (N .GE. 1 .AND. MA .GE. 1) GO TO 20
          IERR = 65
          CALL UTAFSI(1HA,1HF,1HB,1H2,1HD,IERR)
          GO TO 890
   20  CONTINUE
       IERR = 0
       M = ML + MU + 1
       DO 50 I = 1, N
          J0 = MAX0(1,I-ML)
          J1 = MIN0(N,I+MU)
          DO 30 J = J0, J1
             K = J - I + ML + 1
             Z(J) = A(I,K)
   30     CONTINUE
          DO 40 J = J0, J1
             A(I,J) = Z(J)
   40     CONTINUE
   50  CONTINUE
       ANORM = 0.D0
       DO 80 J = 1, N
          I0 = MAX0(1,J-MU)
          I1 = MIN0(N,J+ML)
          DO 60 I = I0, I1
             K = I - J + M
             Z(K) = A(I,J)
   60     CONTINUE
          S = 0.0D0
          DO 70 I = I0, I1
             K = I - J + M
             A(K,J) = Z(K)
             S = S + DABS(Z(K))
   70     CONTINUE
          IF (S .GT. ANORM) ANORM = S
   80  CONTINUE
       J0 = MU + 2
       J1 = MIN0(N,M) - 1
       IF (J1 .LT. J0) GO TO 110
          DO 100 JZ = J0, J1
             I0 = M + 1 - JZ
             DO 90 I = I0, ML
                A(I,JZ) = 0.0D0
   90        CONTINUE
  100     CONTINUE
  110  CONTINUE
       JZ = J1
       JU = 0
       NM1 = N - 1
       IF (NM1 .LT. 1) GO TO 310
          DO 300 K = 1, NM1
             KP1 = K + 1
             JZ = JZ + 1
             IF (JZ .GT. N) GO TO 130
                IF (ML .LT. 1) GO TO 130
                   DO 120 I = 1, ML
                      A(I,JZ) = 0.0D0
  120              CONTINUE
  130           CONTINUE
                LM = MIN0(ML,N-K)
                L = M
                S = DABS(A(M,K))
                I0 = M + 1
                I1 = M + LM
                DO 150 I = I0, I1
                   IF (DABS(A(I,K)) .LE. S) GO TO 140
                      L = I
                      S = DABS(A(I,K))
  140              CONTINUE
  150           CONTINUE
                NLEAD(K) = L + K - M
                IF (A(L,K) .EQ. 0.0D0) GO TO 280
                   IF (L .EQ. M) GO TO 160
                      T = A(L,K)
                      A(L,K) = A(M,K)
                      A(M,K) = T
  160              CONTINUE
                   T = -1.D0/A(M,K)
                   I0 = M + 1
                   I1 = M + LM
                   I = MOD(LM,5) + M
                   IF (I .EQ. M) GO TO 180
                      DO 170 J = I0, I
                         A(J,K) = T*A(J,K)
  170                 CONTINUE
  180              CONTINUE
                   I = I + 1
                   IF (I .GT. I1) GO TO 200
                      DO 190 J = I, I1, 5
                         A(J,K) = T*A(J,K)
                         A(J+1,K) = T*A(J+1,K)
                         A(J+2,K) = T*A(J+2,K)
                         A(J+3,K) = T*A(J+3,K)
                         A(J+4,K) = T*A(J+4,K)
  190                 CONTINUE
  200              CONTINUE
                   JU = MIN0(MAX0(JU,MU+NLEAD(K)),N)
                   MM = M
                   IF (JU .LT. KP1) GO TO 270
                      DO 260 J = KP1, JU
                         L = L - 1
                         MM = MM - 1
                         T = A(L,J)
                         IF (L .EQ. MM) GO TO 210
                            A(L,J) = A(MM,J)
                            A(MM,J) = T
  210                    CONTINUE
                         I0 = M + 1
                         I1 = M + LM
                         I = MOD(LM,4) + M
                         IF (I .EQ. M) GO TO 230
                            DO 220 JJ = I0, I
                               KB = JJ + MM - M
                               A(KB,J) = A(KB,J) + T*A(JJ,K)
  220                       CONTINUE
  230                    CONTINUE
                         I = I + 1
                         IF (I .GT. I1) GO TO 250
                            DO 240 JJ = I, I1, 4
                               KB = JJ + MM - M
                               A(KB,J) = A(KB,J) + T*A(JJ,K)
                               A(KB+1,J) = A(KB+1,J) + T*A(JJ+1,K)
                               A(KB+2,J) = A(KB+2,J) + T*A(JJ+2,K)
                               A(KB+3,J) = A(KB+3,J) + T*A(JJ+3,K)
  240                       CONTINUE
  250                    CONTINUE
  260                 CONTINUE
  270              CONTINUE
                   GO TO 290
  280        CONTINUE
             IERR = -K
  290     CONTINUE
  300  CONTINUE
  310  CONTINUE
       IF (A(M,N) .EQ. 0.0D0) IERR = -N
       NLEAD(N) = N
       IF (IERR .EQ. 0) GO TO 320
          CALL UTAFSI(1HA,1HF,1HB,1H2,1HD,IERR)
          GO TO 820
  320  CONTINUE
       EK = 1.D0
       DO 330 J = 1, N
          Z(J) = 0.0D0
  330  CONTINUE
       JU = 0
       DO 470 K = 1, N
          IF (Z(K) .NE. 0.D0) EK = DSIGN(EK,-Z(K))
          IF (DABS(EK-Z(K)) .LE. DABS(A(M,K))) GO TO 400
             S = DABS(A(M,K))/DABS(EK-Z(K))
             ASSIGN 390 TO LL
  340     CONTINUE
          I = MOD(N,5)
          IF (I .EQ. 0) GO TO 360
             DO 350 JJ = 1, I
                Z(JJ) = S*Z(JJ)
  350        CONTINUE
             IF (N .LT. 5) GO TO 380
  360        CONTINUE
             I = I + 1
             DO 370 JJ = I, N, 5
                Z(JJ) = S*Z(JJ)
                Z(JJ+1) = S*Z(JJ+1)
                Z(JJ+2) = S*Z(JJ+2)
                Z(JJ+3) = S*Z(JJ+3)
                Z(JJ+4) = S*Z(JJ+4)
  370        CONTINUE
  380     CONTINUE
          GO TO LL,(390,540,590,630,680,720,730,810)
  390     CONTINUE
          EK = S*EK
  400     CONTINUE
          WK = EK - Z(K)
          WKM = -EK - Z(K)
          S = DABS(WK)
          SM = DABS(WKM)
          IF (A(M,K) .EQ. 0.0D0) GO TO 410
             WK = WK/A(M,K)
             WKM = WKM/A(M,K)
             GO TO 420
  410     CONTINUE
          WK = 1.D0
          WKM = 1.D0
  420     CONTINUE
          KP1 = K + 1
          JU = MIN0(MAX0(JU,MU+NLEAD(K)),N)
          MM = M
          IF (KP1 .GT. JU) GO TO 460
             DO 430 J = KP1, JU
                MM = MM - 1
                SM = SM + DABS(Z(J) + WKM*A(MM,J))
                Z(J) = Z(J) + WK*A(MM,J)
                S = S + DABS(Z(J))
  430        CONTINUE
             IF (S .GE. SM) GO TO 450
                T = WKM - WK
                WK = WKM
                MM = M
                DO 440 J = KP1, JU
                   MM = MM - 1
                   Z(J) = Z(J) + T*A(MM,J)
  440           CONTINUE
  450        CONTINUE
  460     CONTINUE
          Z(K) = WK
  470  CONTINUE
       ASSIGN 530 TO LL
  480  CONTINUE
       S = 0.0D0
       I = MOD(N,6)
       IF (I .EQ. 0) GO TO 500
          DO 490 JJ = 1, I
             S = S + DABS(Z(JJ))
  490     CONTINUE
          IF (N .LT. 6) GO TO 520
  500     CONTINUE
          I = I + 1
          DO 510 JJ = I, N, 6
             S = S + DABS(Z(JJ)) + DABS(Z(JJ+1)) + DABS(Z(JJ+2)) +
     1           DABS(Z(JJ+3)) + DABS(Z(JJ+4)) + DABS(Z(JJ+5))
  510     CONTINUE
  520  CONTINUE
       S = 1.0D0/S
       GO TO LL,(530,620,710,800)
  530  CONTINUE
       ASSIGN 540 TO LL
       GO TO 340
  540  CONTINUE
       DO 610 KB = 1, N
          K = N + 1 - KB
          LM = MIN0(ML,N-K)
          IF (K .GE. N) GO TO 580
             I0 = M + 1
             I1 = M + LM
             I = MOD(LM,5) + M
             IF (I .EQ. M) GO TO 560
                DO 550 JJ = I0, I
                   KP1 = JJ + K - M
                   Z(K) = Z(K) + A(JJ,K)*Z(KP1)
  550           CONTINUE
  560        CONTINUE
             I = I + 1
             IF (I .GT. I1) GO TO 580
                DO 570 JJ = I, I1, 5
                   KP1 = JJ + K - M
                   Z(K) = Z(K) + A(JJ,K)*Z(KP1) + A(JJ+1,K)*Z(KP1+1)
     1                     + A(JJ+2,K)*Z(KP1+2) + A(JJ+3,K)*Z(KP1+3)
     2                     + A(JJ+4,K)*Z(KP1+4)
  570           CONTINUE
  580        CONTINUE
             IF (DABS(Z(K)) .LE. 1.0D0) GO TO 600
                S = 1.0D0/DABS(Z(K))
                ASSIGN 590 TO LL
                GO TO 340
  590     CONTINUE
  600     CONTINUE
          L = NLEAD(K)
          T = Z(L)
          Z(L) = Z(K)
          Z(K) = T
  610  CONTINUE
       ASSIGN 620 TO LL
       GO TO 480
  620  CONTINUE
       ASSIGN 630 TO LL
       GO TO 340
  630  CONTINUE
       YNORM = 1.D0
       DO 700 K = 1, N
          L = NLEAD(K)
          T = Z(L)
          Z(L) = Z(K)
          Z(K) = T
          LM = MIN0(ML,N-K)
          IF (K .GE. N) GO TO 670
             I0 = M + 1
             I1 = M + LM
             I = MOD(LM,4) + M
             IF (I .EQ. M) GO TO 650
                DO 640 JJ = I0, I
                   KP1 = JJ + K - M
                   Z(KP1) = Z(KP1) + T*A(JJ,K)
  640           CONTINUE
  650        CONTINUE
             I = I + 1
             IF (I .GT. I1) GO TO 670
                DO 660 JJ = I, I1, 4
                   KP1 = JJ + K - M
                   Z(KP1) = Z(KP1) + T*A(JJ,K)
                   Z(KP1+1) = Z(KP1+1) + T*A(JJ+1,K)
                   Z(KP1+2) = Z(KP1+2) + T*A(JJ+2,K)
                   Z(KP1+3) = Z(KP1+3) + T*A(JJ+3,K)
  660           CONTINUE
  670        CONTINUE
             IF (DABS(Z(K)) .LE. 1.0D0) GO TO 690
                S = 1.0D0/DABS(Z(K))
                ASSIGN 680 TO LL
                GO TO 340
  680     CONTINUE
          YNORM = S*YNORM
  690     CONTINUE
  700  CONTINUE
       ASSIGN 710 TO LL
       GO TO 480
  710  CONTINUE
       ASSIGN 720 TO LL
       GO TO 340
  720  CONTINUE
       YNORM = S*YNORM
       DO 790 KB = 1, N
          K = N + 1 - KB
          IF (DABS(Z(K)) .LE. DABS(A(M,K))) GO TO 740
             S = DABS(A(M,K))/DABS(Z(K))
             ASSIGN 730 TO LL
             GO TO 340
  730     CONTINUE
          YNORM = S*YNORM
  740     CONTINUE
          IF (A(M,K) .NE. 0.D0) Z(K) = Z(K)/A(M,K)
          IF (A(M,K) .EQ. 0.D0) Z(K) = 1.D0
          T = -Z(K)
          LM = MIN0(K,M) - 1
          IF (LM .LT. 1) GO TO 780
             I0 = M - LM
             I1 = M - 1
             I = MOD(LM,4) + I0 - 1
             IF (I .LT. I0) GO TO 760
                DO 750 JJ = I0, I
                   KP1 = JJ + K - M
                   Z(KP1) = Z(KP1) + T*A(JJ,K)
  750           CONTINUE
  760        CONTINUE
             I = I + 1
             IF (I .GT. I1) GO TO 780
                DO 770 JJ = I, I1, 4
                   KP1 = JJ + K - M
                   Z(KP1) = Z(KP1) + T*A(JJ,K)
                   Z(KP1+1) = Z(KP1+1) + T*A(JJ+1,K)
                   Z(KP1+2) = Z(KP1+2) + T*A(JJ+2,K)
                   Z(KP1+3) = Z(KP1+3) + T*A(JJ+3,K)
  770           CONTINUE
  780        CONTINUE
  790     CONTINUE
          ASSIGN 800 TO LL
          GO TO 480
  800  CONTINUE
       ASSIGN 810 TO LL
       GO TO 340
  810  CONTINUE
       YNORM = S*YNORM
       IF (ANORM .NE. 0.D0) RCOND = YNORM/ANORM
  820  CONTINUE
       DO 850 J = 1, N
          I0 = MAX0(1,J-MU-ML)
          I1 = MIN0(N,J+ML)
          DO 830 I = I0, I1
             K = I - J + M
             Z(I) = A(K,J)
             A(K,J) = 0.0D0
  830     CONTINUE
          DO 840 I = I0, I1
             A(I,J) = Z(I)
  840     CONTINUE
  850  CONTINUE
       DO 880 I = 1, N
          J0 = MAX0(1,I-ML)
          J1 = MIN0(N,I+MU+ML)
          DO 860 J = J0, J1
             K = J - I + ML + 1
             Z(K) = A(I,J)
             A(I,J) = 0.0D0
  860     CONTINUE
          DO 870 J = J0, J1
             K = J - I + ML + 1
             A(I,K) = Z(K)
  870     CONTINUE
  880  CONTINUE
  890  CONTINUE
       RETURN
      END
